﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Common
{
    public class StringFormatConverter : Windows.UI.Xaml.Data.IValueConverter
    {
        public object Convert(object value, Type targetType, object parameter, string language)
        {
            // No format provided.
            string returnValue = string.Empty;

            if (parameter == null)
            {
                return value;
            }

            switch (value.GetType().Name)
            {
                case "Double":
                case "double":
                    var dvalue = System.Convert.ToDouble(value);
                    returnValue = string.Format((String)parameter, dvalue);
                    break;
                case "Single":
                case "single":
                    var svalue = System.Convert.ToSingle(value);
                    returnValue = string.Format((String)parameter, svalue);
                    break;
                case "DateTime":
                    var dtvalue = System.Convert.ToDateTime(value);
                    returnValue = string.Format((string)parameter, dtvalue);
                    break;
                default:
                    var ivalue = System.Convert.ToInt64(value);
                    returnValue = String.Format((String)parameter, ivalue);
                    break;
            }
            return returnValue;
        }

        public object ConvertBack(object value, Type targetType, object parameter, string language)
        {
            return value;
        }
    }
}

