﻿using App2.Models;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace App2.ViewModels
{
    public class SamplePageViewModel : App2.Common.BindableBase
    {
        private CarModel currentCar;
        public CarModel CurrentCar 
        {
            get { return currentCar; }
            set 
            {
                currentCar = value;
                OnPropertyChanged();
            }
        }

        public ObservableCollection<CarModel> CarCollection { get; set; }

        public SamplePageViewModel()
        {
            CarCollection = new ObservableCollection<CarModel>();
            if (Windows.ApplicationModel.DesignMode.DesignModeEnabled)
            {
                CurrentCar = new CarModel { CarName = "아우디", CarPrice = 50000000, CarColor = "파란색", IsSago = false };
                CarCollection.Add(CurrentCar);
                CurrentCar = new CarModel { CarName = "람보", CarPrice = 350000000, CarColor = "노란색", IsSago = true };
                CarCollection.Add(CurrentCar);
                CurrentCar = new CarModel { CarName = "티코", CarPrice = 10000000, CarColor = "갈색", IsSago = false };
                CarCollection.Add(CurrentCar);
                CurrentCar = new CarModel { CarName = "마티즈", CarPrice = 15000000, CarColor = "쥐색", IsSago = true };
                CarCollection.Add(CurrentCar);
                CurrentCar = new CarModel { CarName = "아반떼", CarPrice = 20000000, CarColor = "흰색", IsSago = false };
                CarCollection.Add(CurrentCar);
            }
            else
            {
            }
        }

        private DelegateCommand changeCommand;
        /// <summary>
        /// 변경 커맨드
        /// </summary>
        public DelegateCommand ChangeCommand
        {
            get 
            {
                if (changeCommand == null)
                {
                    changeCommand = new DelegateCommand(
                        args => 
                        {
                            CurrentCar.CarName = "람보";
                            CurrentCar.CarPrice = 300000000;
                            CurrentCar.CarColor = "빨간색";
                            CurrentCar.IsSago = true;
                        });
                }
                return changeCommand; 
            }
        }

        private DelegateCommand addCommand;
        /// <summary>
        /// 추가 커맨드
        /// </summary>
        public DelegateCommand AddCommand
        {
            get
            {
                if (addCommand == null)
                {
                    addCommand = new DelegateCommand(
                        args =>
                        {
                            CurrentCar = new CarModel { CarName = "아우디" + CarCollection.Count.ToString(), CarPrice = 50000000, CarColor = "파란색", IsSago = false };
                            CarCollection.Add(CurrentCar);
                        });
                }
                return addCommand;
            }
        }
    }
}
